Prefs = {}
Prefs.fontWidth=8;
Prefs.fontHeight=8;
Prefs.fgColor=7;
Prefs.bgColor=0;

function SessionAssistant() {

	this.termplugin	= undefined;
	this.placeholder = undefined;
	this.headerHeight = undefined;
	this.footerHeight = undefined;
	this.terminalWidth = undefined;
	this.terminalHeight = undefined;
	this.scroller = undefined;

	this._onKeyDownEventHandler = this._onKeyDownEvent.bind(this);
	
}

SessionAssistant.prototype.setup = function() {

	try {

		Mojo.Log.info("SessionAssistant#setup");

		var targetWindow = this.controller.window;
		if (targetWindow.PalmSystem && targetWindow.PalmSystem.setWindowOrientation) {
			targetWindow.PalmSystem.setWindowOrientation("free");
		}
		delete targetWindow;

		var attributes = {
                omitDefaultItems: true
		}

		var model = {
				visible: true,
				items: [
			            {label: "New Session", command: 'do-newSession'},
			            { label: "Preferences...", command: 'do-prefs' },
				        ]
		}
		
		this.controller.setupWidget(Mojo.Menu.appMenu, attributes, model);

		// Allow override of 'back' gesture in landscape mode.
		this.controller.useLandscapePageUpDown(true);

		//this.controller.enableFullScreenMode(true);

		this.scroller = this.controller.get('scrollerId');

		this.controller.document.addEventListener("keydown", this._onKeyDownEventHandler, true);

		this.terminalWidth = this.controller.window.innerWidth;
		this.terminalHeight = this.controller.window.innerHeight;

		this.termplugin = this.controller.document.createElement('object');
		this.termplugin.setAttribute('type', 'application/x-webosinternals-termplugin');
		this.termplugin.setAttribute('width', this.terminalWidth);
		this.termplugin.setAttribute('height', 1000*8);
		this.termplugin.setAttribute('style', 'padding-bottom: 44px;');

		this.controller.document.addEventListener("keydown", this._onKeyDownEventHandler, true);

		this.placeholder = this.controller.get('install_object_here');
		this.placeholder.parentNode.replaceChild(this.termplugin, this.placeholder);

		this.termplugin.start("root");

	} catch (e) {

		Mojo.Log.logException(e, 'PageAssistant#setup');

	}

	this.scroller.setStyle({'height':this.terminalHeight+5+'px'});

}

SessionAssistant.prototype.activate = function(event) {

	this.termplugin.setFont(Prefs.fontWidth,Prefs.fontHeight);
	this.termplugin.setColors(Prefs.fgColor,Prefs.bgColor);
	this.termplugin.focus();
	this.termplugin.setTerminalHeight(this.terminalHeight-38);
	this.scroller.mojo.revealBottom();

}


SessionAssistant.prototype.deactivate = function(event) {

}

SessionAssistant.prototype.cleanup = function(event) {

	this.controller.document.removeEventListener("keydown", this._onKeyDownEventHandler, true);

}

SessionAssistant.prototype._onKeyDownEvent = function(event) {

	if (event.keyCode==13) {
		this.termplugin.sendEnter();
	}

}


SessionAssistant.prototype.newCard = function(scene,stagename) {
	var appController = Mojo.Controller.getAppController();
	var f = function(stageController) {
		stageController.pushScene(scene);       
	};
	appController.createStageWithCallback({name: stagename, lightweight: true}, f);
	delete f;
	delete appController;
}

SessionAssistant.prototype.handleCommand = function(event) {

	if (event.type == Mojo.Event.command) {

		switch (event.command) {

		case 'do-newSession':
			this.newCard("session", "session-"+Date.now());
			break;

		case 'do-prefs':
			var appController = Mojo.Controller.getAppController();
			var stageController = appController.getActiveStageController();
			stageController.pushScene('prefs');
			//this.newCard("prefs", "prefs");
			break;

		}

	}

}
